# Use cases with `ragconnect`

## 1⃣ MPM4CPS Paper - Codename 'Ros2Rag'

In the publication "Connecting conceptual models using Relational Reference Attribute Grammars" (⚠ DOI pending), a use case involving a simulated robot arm and two different models conencted to it was shown.
One model was used to ensure a low speed of the robot when within a safety zone (purple boxes in the picture below), and the other model executes a workflow to control the robot.

![](material/robo3d.png)

The repository with the used source code can be found at: <https://git-st.inf.tu-dresden.de/ceti/ros/mpm4cps2020>
The usage is dockerized, so starting the application involves the commands listed below.
As ROS takes some time to start up, it is best to use separate terminals for the three applications (ROS, Safety-Model, Goal-Model):

```bash
# Preparation (only need once)
./prepare-docker-compose.sh
docker-compose up -d mosquitto  # Starts the MQTT broker

# Terminal 1
docker-compose up --build ros
# Wait until you see no more new logging output

# Terminal 2
docker-compose up rag_app

# Terminal 3
docker-compose up rag_goal
```
